/*
 * Swagger Petstore
 * This spec is mainly for testing Petstore server and contains fake endpoints, models. Please do not use this for any other purpose. Special characters: \" \\
 *
 * OpenAPI spec version: 1.0.0
 * Contact: apiteam@swagger.io
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.6-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  var testDataFile = process.env.TEST_DATA_FILE
    ? process.env.TEST_DATA_FILE
    : 'C:\\source\\GitHub\\demonfiddler\\swagger-codegen\\samples\\client\\petstore\\javascript-override-default-config\\test\\test-data.json';
  if (typeof define === 'function' && define.amd) {
    // AMD.
    define(['expect.js', 'json-pointer', '../../assert-equals', '../../../js/petstore/index', testDataFile], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    factory(require('expect.js'), require('json-pointer'), require('../../assert-equals'), require('../../../js/petstore/index'), require(testDataFile));
  } else {
    // Browser globals (root is window)
    // TODO: load browser test data from file. Maybe via FileSystem (Mozilla, chrome.fileSystem)?
    var testData = null;
    factory(root.expect, root.JsonPointer, root.assertEquals, root.SwaggerPetstore, testData);
  }
}(this, function(expect, pointer, assertEquals, SwaggerPetstore, testData) {
  'use strict';

  var instance;
  var testDataCache;

  function getTestData(pointer) {
    return testDataCache.get('/petstore/PetApi' + pointer);
  }

  before(function() {
    testDataCache = pointer(testData);
  });


  beforeEach(function() {
    instance = new SwaggerPetstore.PetApi();
  });

  describe('petstore', function() {
    describe('PetApi', function() {
      describe('addPet', function() {
        it('should call addPet successfully', function(done) {
          var body = getTestData('/addPet/body');

          instance.addPet(body, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }

            done();
          });
        });
      });
      describe('deletePet', function() {
        it('should call deletePet successfully', function(done) {
          var petId = getTestData('/deletePet/petId');
          var opts = {};
          opts.apiKey = getTestData('/deletePet/apiKey');

          instance.deletePet(petId, opts, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }

            done();
          });
        });
      });
      describe('findPetsByStatus', function() {
        it('should call findPetsByStatus successfully', function(done) {
          var status = getTestData('/findPetsByStatus/status');

          instance.findPetsByStatus(status, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }
            let expected = getTestData('/findPetsByStatus/response');
            assertEquals(expected, data);

            done();
          });
        });
      });
      describe('findPetsByTags', function() {
        it('should call findPetsByTags successfully', function(done) {
          var tags = getTestData('/findPetsByTags/tags');

          instance.findPetsByTags(tags, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }
            let expected = getTestData('/findPetsByTags/response');
            assertEquals(expected, data);

            done();
          });
        });
      });
      describe('getPetById', function() {
        it('should call getPetById successfully', function(done) {
          var petId = getTestData('/getPetById/petId');

          instance.getPetById(petId, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }
            let expected = getTestData('/getPetById/response');
            assertEquals(expected, data);

            done();
          });
        });
      });
      describe('updatePet', function() {
        it('should call updatePet successfully', function(done) {
          var body = getTestData('/updatePet/body');

          instance.updatePet(body, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }

            done();
          });
        });
      });
      describe('updatePetWithForm', function() {
        it('should call updatePetWithForm successfully', function(done) {
          var petId = getTestData('/updatePetWithForm/petId');
          var opts = {};
          opts.name = getTestData('/updatePetWithForm/name');
          opts.status = getTestData('/updatePetWithForm/status');

          instance.updatePetWithForm(petId, opts, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }

            done();
          });
        });
      });
      describe('uploadFile', function() {
        it('should call uploadFile successfully', function(done) {
          var petId = getTestData('/uploadFile/petId');
          var opts = {};
          opts.additionalMetadata = getTestData('/uploadFile/additionalMetadata');
          opts.file = getTestData('/uploadFile/file');

          instance.uploadFile(petId, opts, function(error, data, response) {
            if (error) {
              done(error);
              return;
            }
            let expected = getTestData('/uploadFile/response');
            assertEquals(expected, data);

            done();
          });
        });
      });
    });
  });

}));
